# CKAdapter is an interface between CGIKit and a web server.
# This object has a reference to a request/response object
# created by a CKAdaptee object.
# 
# The role of CKAdapter is to provide the consistent interface to 
# CKApplication. The difference of the relatioship between 
# CGIKit and a web server is aboserbed by a CKAdaptee obejct. 
class CKAdapter
	attr_accessor :adaptee

        # interface corresponds to adaptee's class and filename.
	def initialize( interface )
		@interface = interface
		@adaptee   = _adaptee
	end

	def run( response )
		@adaptee.out response
	end

	def create_request
		@adaptee.request
	end

	def create_response
		@adaptee.response
	end

	private

	def _adaptee
		if    @interface == 'fastcgi'  then _interface = 'FastCGI'
		elsif @interface == 'mod_ruby' then _interface = 'ModRuby'
		else
			_interface = 'CGI'
		end

		klass = CKAdaptee.const_get( _interface )
		klass.new
	end
end
